fix initial values of reallocated fluids
[bpt/guile.git] / maint.mk
CommitLineData
c84bdaf6
LC
1# -*-Makefile-*-
2# This Makefile fragment tries to be general-purpose enough to be
3# used by many projects via the gnulib maintainer-makefile module.
4
49114fd4 5## Copyright (C) 2001-2011 Free Software Foundation, Inc.
c84bdaf6
LC
6##
7## This program is free software: you can redistribute it and/or modify
8## it under the terms of the GNU General Public License as published by
9## the Free Software Foundation, either version 3 of the License, or
10## (at your option) any later version.
11##
12## This program is distributed in the hope that it will be useful,
13## but WITHOUT ANY WARRANTY; without even the implied warranty of
14## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15## GNU General Public License for more details.
16##
17## You should have received a copy of the GNU General Public License
18## along with this program. If not, see <http://www.gnu.org/licenses/>.
19
20# This is reported not to work with make-3.79.1
21# ME := $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))
22ME := maint.mk
23
24# Override this in cfg.mk if you use a non-standard build-aux directory.
25build_aux ?= $(srcdir)/build-aux
26
27# Do not save the original name or timestamp in the .tar.gz file.
28# Use --rsyncable if available.
29gzip_rsyncable := \
a927b6c1
LC
30 $(shell gzip --help 2>/dev/null|grep rsyncable >/dev/null \
31 && printf %s --rsyncable)
c84bdaf6
LC
32GZIP_ENV = '--no-name --best $(gzip_rsyncable)'
33
c84bdaf6
LC
34GIT = git
35VC = $(GIT)
dd7d0148 36VC-tag = git tag -s -m '$(VERSION)' 'v$(VERSION)' -u '$(gpg_key_ID)'
c84bdaf6
LC
37
38VC_LIST = $(build_aux)/vc-list-files -C $(srcdir)
39
61cd9dc9
LC
40# You can override this variable in cfg.mk to set your own regexp
41# matching files to ignore.
42VC_LIST_ALWAYS_EXCLUDE_REGEX ?= ^$$
43
44# This is to preprocess robustly the output of $(VC_LIST), so that even
45# when $(srcdir) is a pathological name like "....", the leading sed command
46# removes only the intended prefix.
47_dot_escaped_srcdir = $(subst .,\.,$(srcdir))
48
49# Post-process $(VC_LIST) output, prepending $(srcdir)/, but only
50# when $(srcdir) is not ".".
51ifeq ($(srcdir),.)
52_prepend_srcdir_prefix =
53else
54_prepend_srcdir_prefix = | sed 's|^|$(srcdir)/|'
55endif
56
57# In order to be able to consistently filter "."-relative names,
58# (i.e., with no $(srcdir) prefix), this definition is careful to
59# remove any $(srcdir) prefix, and to restore what it removes.
dd7d0148
LC
60_sc_excl = \
61 $(if $(exclude_file_name_regexp--$@),$(exclude_file_name_regexp--$@),^$$)
c84bdaf6 62VC_LIST_EXCEPT = \
61cd9dc9
LC
63 $(VC_LIST) | sed 's|^$(_dot_escaped_srcdir)/||' \
64 | if test -f $(srcdir)/.x-$@; then grep -vEf $(srcdir)/.x-$@; \
65 else grep -Ev -e "$${VC_LIST_EXCEPT_DEFAULT-ChangeLog}"; fi \
dd7d0148 66 | grep -Ev -e '($(VC_LIST_ALWAYS_EXCLUDE_REGEX)|$(_sc_excl))' \
61cd9dc9 67 $(_prepend_srcdir_prefix)
c84bdaf6
LC
68
69ifeq ($(origin prev_version_file), undefined)
70 prev_version_file = $(srcdir)/.prev-version
71endif
72
73PREV_VERSION := $(shell cat $(prev_version_file) 2>/dev/null)
74VERSION_REGEXP = $(subst .,\.,$(VERSION))
75PREV_VERSION_REGEXP = $(subst .,\.,$(PREV_VERSION))
76
77ifeq ($(VC),$(GIT))
78this-vc-tag = v$(VERSION)
79this-vc-tag-regexp = v$(VERSION_REGEXP)
80else
81tag-package = $(shell echo "$(PACKAGE)" | tr '[:lower:]' '[:upper:]')
82tag-this-version = $(subst .,_,$(VERSION))
83this-vc-tag = $(tag-package)-$(tag-this-version)
84this-vc-tag-regexp = $(this-vc-tag)
85endif
86my_distdir = $(PACKAGE)-$(VERSION)
87
88# Old releases are stored here.
89release_archive_dir ?= ../release
90
414e4441
LC
91# Override gnu_rel_host and url_dir_list in cfg.mk if these are not right.
92# Use alpha.gnu.org for alpha and beta releases.
93# Use ftp.gnu.org for stable releases.
94gnu_ftp_host-alpha = alpha.gnu.org
95gnu_ftp_host-beta = alpha.gnu.org
96gnu_ftp_host-stable = ftp.gnu.org
97gnu_rel_host ?= $(gnu_ftp_host-$(RELEASE_TYPE))
98
99ifeq ($(gnu_rel_host),ftp.gnu.org)
100url_dir_list ?= http://ftpmirror.gnu.org/$(PACKAGE)
101else
102url_dir_list ?= ftp://$(gnu_rel_host)/gnu/$(PACKAGE)
103endif
104
1cd4fffc
LC
105# Override this in cfg.mk if you are using a different format in your
106# NEWS file.
107today = $(shell date +%Y-%m-%d)
9157d901
LC
108
109# Select which lines of NEWS are searched for $(news-check-regexp).
110# This is a sed line number spec. The default says that we search
111# lines 1..10 of NEWS for $(news-check-regexp).
112# If you want to search only line 3 or only lines 20-22, use "3" or "20,22".
113news-check-lines-spec ?= 1,10
1cd4fffc
LC
114news-check-regexp ?= '^\*.* $(VERSION_REGEXP) \($(today)\)'
115
c84bdaf6
LC
116# Prevent programs like 'sort' from considering distinct strings to be equal.
117# Doing it here saves us from having to set LC_ALL elsewhere in this file.
118export LC_ALL = C
119
120## --------------- ##
121## Sanity checks. ##
122## --------------- ##
123
124_cfg_mk := $(shell test -f $(srcdir)/cfg.mk && echo '$(srcdir)/cfg.mk')
125
126# Collect the names of rules starting with `sc_'.
127syntax-check-rules := $(sort $(shell sed -n 's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' \
128 $(srcdir)/$(ME) $(_cfg_mk)))
129.PHONY: $(syntax-check-rules)
130
dd36ce77
MW
131ifeq ($(shell $(VC_LIST) >/dev/null 2>&1; echo $$?),0)
132local-checks-available += $(syntax-check-rules)
133else
134local-checks-available += no-vc-detected
135no-vc-detected:
136 @echo "No version control files detected; skipping syntax check"
137endif
c84bdaf6
LC
138.PHONY: $(local-checks-available)
139
140# Arrange to print the name of each syntax-checking rule just before running it.
141$(syntax-check-rules): %: %.m
dde9c5a4
LC
142sc_m_rules_ = $(patsubst %, %.m, $(syntax-check-rules))
143.PHONY: $(sc_m_rules_)
144$(sc_m_rules_):
c84bdaf6 145 @echo $(patsubst sc_%.m, %, $@)
a927b6c1
LC
146 @date +%s.%N > .sc-start-$(basename $@)
147
148# Compute and print the elapsed time for each syntax-check rule.
149sc_z_rules_ = $(patsubst %, %.z, $(syntax-check-rules))
150.PHONY: $(sc_z_rules_)
151$(sc_z_rules_): %.z: %
152 @end=$$(date +%s.%N); \
153 start=$$(cat .sc-start-$*); \
154 rm -f .sc-start-$*; \
155 awk -v s=$$start -v e=$$end \
156 'END {printf "%.2f $(patsubst sc_%,%,$*)\n", e - s}' < /dev/null
157
158# The patsubst here is to replace each sc_% rule with its sc_%.z wrapper
159# that computes and prints elapsed time.
160local-check := \
161 $(patsubst sc_%, sc_%.z, \
162 $(filter-out $(local-checks-to-skip), $(local-checks-available)))
c84bdaf6
LC
163
164syntax-check: $(local-check)
a927b6c1
LC
165
166# _sc_search_regexp
167#
168# This macro searches for a given construct in the selected files and
169# then takes some action.
170#
171# Parameters (shell variables):
172#
173# prohibit | require
174#
175# Regular expression (ERE) denoting either a forbidden construct
176# or a required construct. Those arguments are exclusive.
177#
178# in_vc_files | in_files
179#
180# grep-E-style regexp denoting the files to check. If no files
181# are specified the default are all the files that are under
182# version control.
183#
184# containing | non_containing
185#
186# Select the files (non) containing strings matching this regexp.
187# If both arguments are specified then CONTAINING takes
188# precedence.
189#
190# with_grep_options
191#
192# Extra options for grep.
193#
194# ignore_case
195#
196# Ignore case.
197#
198# halt
199#
200# Message to display before to halting execution.
dd7d0148
LC
201#
202# Finally, you may exempt files based on an ERE matching file names.
203# For example, to exempt from the sc_space_tab check all files with the
204# .diff suffix, set this Make variable:
205#
206# exclude_file_name_regexp--sc_space_tab = \.diff$
207#
208# Note that while this functionality is mostly inherited via VC_LIST_EXCEPT,
209# when filtering by name via in_files, we explicitly filter out matching
210# names here as well.
a927b6c1
LC
211
212# By default, _sc_search_regexp does not ignore case.
c84bdaf6 213export ignore_case =
a927b6c1 214_ignore_case = $$(test -n "$$ignore_case" && printf %s -i || :)
c84bdaf6 215
a927b6c1
LC
216define _sc_say_and_exit
217 dummy=; : so we do not need a semicolon before each use; \
218 { printf '%s\n' "$(ME): $$msg" 1>&2; exit 1; };
219endef
220
221# _sc_search_regexp used to be named _prohibit_regexp. However,
222# upgrading to the new definition and leaving the old name undefined
223# would usually convert each custom rule using $(_prohibit_regexp)
224# (usually defined in cfg.mk) into a no-op. This definition ensures
225# that people know right away if they're still using the old name.
226# FIXME: remove in 2012.
227_prohibit_regexp = \
228 $(error '*** you need to s/_prohibit_regexp/_sc_search_regexp/, and adapt')
229
230define _sc_search_regexp
231 dummy=; : so we do not need a semicolon before each use; \
232 \
233 : Check arguments; \
234 test -n "$$prohibit" && test -n "$$require" \
235 && { msg='Cannot specify both prohibit and require' \
236 $(_sc_say_and_exit) } || :; \
237 test -z "$$prohibit" && test -z "$$require" \
238 && { msg='Should specify either prohibit or require' \
239 $(_sc_say_and_exit) } || :; \
240 test -n "$$in_vc_files" && test -n "$$in_files" \
241 && { msg='Cannot specify both in_vc_files and in_files' \
242 $(_sc_say_and_exit) } || :; \
243 test "x$$halt" != x \
244 || { msg='halt not defined' $(_sc_say_and_exit) }; \
245 \
246 : Filter by file name; \
247 if test -n "$$in_files"; then \
dd7d0148
LC
248 files=$$(find $(srcdir) | grep -E "$$in_files" \
249 | grep -Ev '$(exclude_file_name_regexp--$@)'); \
a927b6c1
LC
250 else \
251 files=$$($(VC_LIST_EXCEPT)); \
252 if test -n "$$in_vc_files"; then \
253 files=$$(echo "$$files" | grep -E "$$in_vc_files"); \
254 fi; \
255 fi; \
256 \
257 : Filter by content; \
258 test -n "$$files" && test -n "$$containing" \
259 && { files=$$(grep -l "$$containing" $$files); } || :; \
260 test -n "$$files" && test -n "$$non_containing" \
261 && { files=$$(grep -vl "$$non_containing" $$files); } || :; \
262 \
263 : Check for the construct; \
264 if test -n "$$files"; then \
265 if test -n "$$prohibit"; then \
266 grep $$with_grep_options $(_ignore_case) -nE "$$prohibit" $$files \
267 && { msg="$$halt" $(_sc_say_and_exit) } || :; \
268 else \
269 grep $$with_grep_options $(_ignore_case) -LE "$$require" $$files \
270 | grep . \
271 && { msg="$$halt" $(_sc_say_and_exit) } || :; \
272 fi \
273 else :; \
274 fi || :;
c84bdaf6
LC
275endef
276
277sc_avoid_if_before_free:
278 @$(build_aux)/useless-if-before-free \
279 $(useless_free_options) \
280 $$($(VC_LIST_EXCEPT) | grep -v useless-if-before-free) && \
281 { echo '$(ME): found useless "if" before "free" above' 1>&2; \
282 exit 1; } || :
283
284sc_cast_of_argument_to_free:
a927b6c1
LC
285 @prohibit='\<free *\( *\(' halt='don'\''t cast free argument' \
286 $(_sc_search_regexp)
c84bdaf6
LC
287
288sc_cast_of_x_alloc_return_value:
a927b6c1
LC
289 @prohibit='\*\) *x(m|c|re)alloc\>' \
290 halt='don'\''t cast x*alloc return value' \
291 $(_sc_search_regexp)
c84bdaf6
LC
292
293sc_cast_of_alloca_return_value:
a927b6c1
LC
294 @prohibit='\*\) *alloca\>' \
295 halt='don'\''t cast alloca return value' \
296 $(_sc_search_regexp)
c84bdaf6
LC
297
298sc_space_tab:
a927b6c1
LC
299 @prohibit='[ ] ' \
300 halt='found SPACE-TAB sequence; remove the SPACE' \
301 $(_sc_search_regexp)
c84bdaf6
LC
302
303# Don't use *scanf or the old ato* functions in `real' code.
304# They provide no error checking mechanism.
305# Instead, use strto* functions.
306sc_prohibit_atoi_atof:
a927b6c1
LC
307 @prohibit='\<([fs]?scanf|ato([filq]|ll)) *\(' \
308 halt='do not use *scan''f, ato''f, ato''i, ato''l, ato''ll or ato''q' \
309 $(_sc_search_regexp)
c84bdaf6
LC
310
311# Use STREQ rather than comparing strcmp == 0, or != 0.
312sc_prohibit_strcmp:
49114fd4 313 @grep -nE '! *str''cmp *\(|\<str''cmp *\(.+\) *[!=]=' \
c84bdaf6 314 $$($(VC_LIST_EXCEPT)) \
49114fd4
LC
315 | grep -vE ':# *define STRN?EQ\(' && \
316 { echo '$(ME): replace str''cmp calls above with STREQ/STRNEQ' \
c84bdaf6
LC
317 1>&2; exit 1; } || :
318
319# Pass EXIT_*, not number, to usage, exit, and error (when exiting)
414e4441
LC
320# Convert all uses automatically, via these two commands:
321# git grep -l '\<exit *(1)' \
322# | grep -vEf .x-sc_prohibit_magic_number_exit \
323# | xargs --no-run-if-empty \
324# perl -pi -e 's/(^|[^.])\b(exit ?)\(1\)/$1$2(EXIT_FAILURE)/'
325# git grep -l '\<exit *(0)' \
326# | grep -vEf .x-sc_prohibit_magic_number_exit \
327# | xargs --no-run-if-empty \
328# perl -pi -e 's/(^|[^.])\b(exit ?)\(0\)/$1$2(EXIT_SUCCESS)/'
c84bdaf6 329sc_prohibit_magic_number_exit:
a927b6c1
LC
330 @prohibit='(^|[^.])\<(usage|exit) ?\([0-9]|\<error ?\([1-9][0-9]*,' \
331 halt='use EXIT_* values rather than magic number' \
332 $(_sc_search_regexp)
c84bdaf6
LC
333
334# Using EXIT_SUCCESS as the first argument to error is misleading,
335# since when that parameter is 0, error does not exit. Use `0' instead.
336sc_error_exit_success:
a927b6c1
LC
337 @prohibit='error *\(EXIT_SUCCESS,' \
338 in_vc_files='\.[chly]$$' \
339 halt='found error (EXIT_SUCCESS' \
340 $(_sc_search_regexp)
c84bdaf6
LC
341
342# `FATAL:' should be fully upper-cased in error messages
343# `WARNING:' should be fully upper-cased, or fully lower-cased
344sc_error_message_warn_fatal:
a927b6c1 345 @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \
c84bdaf6
LC
346 | grep -E '"Warning|"Fatal|"fatal' && \
347 { echo '$(ME): use FATAL, WARNING or warning' 1>&2; \
348 exit 1; } || :
349
350# Error messages should not start with a capital letter
351sc_error_message_uppercase:
a927b6c1 352 @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \
c84bdaf6
LC
353 | grep -E '"[A-Z]' \
354 | grep -vE '"FATAL|"WARNING|"Java|"C#|PRIuMAX' && \
355 { echo '$(ME): found capitalized error message' 1>&2; \
356 exit 1; } || :
357
358# Error messages should not end with a period
359sc_error_message_period:
a927b6c1 360 @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \
c84bdaf6
LC
361 | grep -E '[^."]\."' && \
362 { echo '$(ME): found error message ending in period' 1>&2; \
363 exit 1; } || :
364
365sc_file_system:
a927b6c1
LC
366 @prohibit=file''system \
367 ignore_case=1 \
368 halt='found use of "file''system"; spell it "file system"' \
369 $(_sc_search_regexp)
c84bdaf6
LC
370
371# Don't use cpp tests of this symbol. All code assumes config.h is included.
372sc_prohibit_have_config_h:
a927b6c1
LC
373 @prohibit='^# *if.*HAVE''_CONFIG_H' \
374 halt='found use of HAVE''_CONFIG_H; remove' \
375 $(_sc_search_regexp)
c84bdaf6
LC
376
377# Nearly all .c files must include <config.h>. However, we also permit this
378# via inclusion of a package-specific header, if cfg.mk specified one.
379# config_h_header must be suitable for grep -E.
380config_h_header ?= <config\.h>
381sc_require_config_h:
a927b6c1
LC
382 @require='^# *include $(config_h_header)' \
383 in_vc_files='\.c$$' \
384 halt='the above files do not include <config.h>' \
385 $(_sc_search_regexp)
c84bdaf6
LC
386
387# You must include <config.h> before including any other header file.
388# This can possibly be via a package-specific header, if given by cfg.mk.
389sc_require_config_h_first:
390 @if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then \
391 fail=0; \
392 for i in $$($(VC_LIST_EXCEPT) | grep '\.c$$'); do \
393 grep '^# *include\>' $$i | sed 1q \
394 | grep -E '^# *include $(config_h_header)' > /dev/null \
395 || { echo $$i; fail=1; }; \
396 done; \
397 test $$fail = 1 && \
398 { echo '$(ME): the above files include some other header' \
399 'before <config.h>' 1>&2; exit 1; } || :; \
400 else :; \
401 fi
402
403sc_prohibit_HAVE_MBRTOWC:
a927b6c1
LC
404 @prohibit='\bHAVE_MBRTOWC\b' \
405 halt="do not use $$prohibit; it is always defined" \
406 $(_sc_search_regexp)
c84bdaf6
LC
407
408# To use this "command" macro, you must first define two shell variables:
409# h: the header, enclosed in <> or ""
410# re: a regular expression that matches IFF something provided by $h is used.
a927b6c1 411define _sc_header_without_use
c84bdaf6
LC
412 dummy=; : so we do not need a semicolon before each use; \
413 h_esc=`echo "$$h"|sed 's/\./\\\\./g'`; \
414 if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then \
415 files=$$(grep -l '^# *include '"$$h_esc" \
416 $$($(VC_LIST_EXCEPT) | grep '\.c$$')) && \
417 grep -LE "$$re" $$files | grep . && \
418 { echo "$(ME): the above files include $$h but don't use it" \
419 1>&2; exit 1; } || :; \
420 else :; \
421 fi
422endef
423
424# Prohibit the inclusion of assert.h without an actual use of assert.
425sc_prohibit_assert_without_use:
a927b6c1 426 @h='<assert.h>' re='\<assert *\(' $(_sc_header_without_use)
c84bdaf6
LC
427
428# Prohibit the inclusion of close-stream.h without an actual use.
429sc_prohibit_close_stream_without_use:
a927b6c1 430 @h='"close-stream.h"' re='\<close_stream *\(' $(_sc_header_without_use)
c84bdaf6
LC
431
432# Prohibit the inclusion of getopt.h without an actual use.
433sc_prohibit_getopt_without_use:
a927b6c1 434 @h='<getopt.h>' re='\<getopt(_long)? *\(' $(_sc_header_without_use)
c84bdaf6
LC
435
436# Don't include quotearg.h unless you use one of its functions.
437sc_prohibit_quotearg_without_use:
a927b6c1 438 @h='"quotearg.h"' re='\<quotearg(_[^ ]+)? *\(' $(_sc_header_without_use)
c84bdaf6
LC
439
440# Don't include quote.h unless you use one of its functions.
441sc_prohibit_quote_without_use:
a927b6c1 442 @h='"quote.h"' re='\<quote(_n)? *\(' $(_sc_header_without_use)
c84bdaf6
LC
443
444# Don't include this header unless you use one of its functions.
445sc_prohibit_long_options_without_use:
446 @h='"long-options.h"' re='\<parse_long_options *\(' \
a927b6c1 447 $(_sc_header_without_use)
c84bdaf6
LC
448
449# Don't include this header unless you use one of its functions.
450sc_prohibit_inttostr_without_use:
451 @h='"inttostr.h"' re='\<(off|[iu]max|uint)tostr *\(' \
a927b6c1 452 $(_sc_header_without_use)
c84bdaf6 453
61cd9dc9
LC
454# Don't include this header unless you use one of its functions.
455sc_prohibit_ignore_value_without_use:
456 @h='"ignore-value.h"' re='\<ignore_(value|ptr) *\(' \
a927b6c1 457 $(_sc_header_without_use)
61cd9dc9 458
c84bdaf6
LC
459# Don't include this header unless you use one of its functions.
460sc_prohibit_error_without_use:
461 @h='"error.h"' \
462 re='\<error(_at_line|_print_progname|_one_per_line|_message_count)? *\('\
a927b6c1 463 $(_sc_header_without_use)
c84bdaf6
LC
464
465# Don't include xalloc.h unless you use one of its functions.
466# Consider these symbols:
467# perl -lne '/^# *define (\w+)\(/ and print $1' lib/xalloc.h|grep -v '^__';
a927b6c1 468# perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/xalloc.h
c84bdaf6
LC
469# Divide into two sets on case, and filter each through this:
470# | sort | perl -MRegexp::Assemble -le \
471# 'print Regexp::Assemble->new(file => "/dev/stdin")->as_string'|sed 's/\?://g'
472# Note this was produced by the above:
61cd9dc9
LC
473# _xa1 = \
474#x(((2n?)?re|c(har)?|n(re|m)|z)alloc|alloc_(oversized|die)|m(alloc|emdup)|strdup)
475# But we can do better, in at least two ways:
476# 1) take advantage of two "dup"-suffixed strings:
477# x(((2n?)?re|c(har)?|n(re|m)|[mz])alloc|alloc_(oversized|die)|(mem|str)dup)
478# 2) notice that "c(har)?|[mz]" is equivalent to the shorter and more readable
479# "char|[cmz]"
480# x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
481_xa1 = x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
c84bdaf6
LC
482_xa2 = X([CZ]|N?M)ALLOC
483sc_prohibit_xalloc_without_use:
484 @h='"xalloc.h"' \
485 re='\<($(_xa1)|$(_xa2)) *\('\
a927b6c1 486 $(_sc_header_without_use)
c84bdaf6 487
dde9c5a4 488# Extract function names:
a927b6c1 489# perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/hash.h
dde9c5a4
LC
490_hash_re = \
491clear|delete|free|get_(first|next)|insert|lookup|print_statistics|reset_tuning
492_hash_fn = \<($(_hash_re)) *\(
493_hash_struct = (struct )?\<[Hh]ash_(table|tuning)\>
494sc_prohibit_hash_without_use:
495 @h='"hash.h"' \
496 re='$(_hash_fn)|$(_hash_struct)'\
a927b6c1 497 $(_sc_header_without_use)
dde9c5a4
LC
498
499sc_prohibit_hash_pjw_without_use:
500 @h='"hash-pjw.h"' \
501 re='\<hash_pjw *\(' \
a927b6c1 502 $(_sc_header_without_use)
dde9c5a4 503
c84bdaf6
LC
504sc_prohibit_safe_read_without_use:
505 @h='"safe-read.h"' re='(\<SAFE_READ_ERROR\>|\<safe_read *\()' \
a927b6c1 506 $(_sc_header_without_use)
c84bdaf6
LC
507
508sc_prohibit_argmatch_without_use:
509 @h='"argmatch.h"' \
510 re='(\<(ARRAY_CARDINALITY|X?ARGMATCH(|_TO_ARGUMENT|_VERIFY))\>|\<argmatch(_exit_fn|_(in)?valid) *\()' \
a927b6c1 511 $(_sc_header_without_use)
c84bdaf6
LC
512
513sc_prohibit_canonicalize_without_use:
514 @h='"canonicalize.h"' \
515 re='CAN_(EXISTING|ALL_BUT_LAST|MISSING)|canonicalize_(mode_t|filename_mode)' \
a927b6c1 516 $(_sc_header_without_use)
c84bdaf6
LC
517
518sc_prohibit_root_dev_ino_without_use:
519 @h='"root-dev-ino.h"' \
520 re='(\<ROOT_DEV_INO_(CHECK|WARN)\>|\<get_root_dev_ino *\()' \
a927b6c1 521 $(_sc_header_without_use)
c84bdaf6
LC
522
523sc_prohibit_openat_without_use:
524 @h='"openat.h"' \
525 re='\<(openat_(permissive|needs_fchdir|(save|restore)_fail)|l?(stat|ch(own|mod))at|(euid)?accessat)\>' \
a927b6c1 526 $(_sc_header_without_use)
c84bdaf6
LC
527
528# Prohibit the inclusion of c-ctype.h without an actual use.
529ctype_re = isalnum|isalpha|isascii|isblank|iscntrl|isdigit|isgraph|islower\
530|isprint|ispunct|isspace|isupper|isxdigit|tolower|toupper
531sc_prohibit_c_ctype_without_use:
a927b6c1
LC
532 @h='[<"]c-ctype.h[">]' re='\<c_($(ctype_re)) *\(' \
533 $(_sc_header_without_use)
c84bdaf6
LC
534
535_empty =
536_sp = $(_empty) $(_empty)
537# The following list was generated by running:
538# man signal.h|col -b|perl -ne '/bsd_signal.*;/.../sigwaitinfo.*;/ and print' \
539# | perl -lne '/^\s+(?:int|void).*?(\w+).*/ and print $1' | fmt
540_sig_functions = \
541 bsd_signal kill killpg pthread_kill pthread_sigmask raise sigaction \
542 sigaddset sigaltstack sigdelset sigemptyset sigfillset sighold sigignore \
543 siginterrupt sigismember signal sigpause sigpending sigprocmask sigqueue \
544 sigrelse sigset sigsuspend sigtimedwait sigwait sigwaitinfo
545_sig_function_re = $(subst $(_sp),|,$(strip $(_sig_functions)))
546# The following were extracted from "man signal.h" manually.
547_sig_types_and_consts = \
548 MINSIGSTKSZ SA_NOCLDSTOP SA_NOCLDWAIT SA_NODEFER SA_ONSTACK \
549 SA_RESETHAND SA_RESTART SA_SIGINFO SIGEV_NONE SIGEV_SIGNAL \
550 SIGEV_THREAD SIGSTKSZ SIG_BLOCK SIG_SETMASK SIG_UNBLOCK SS_DISABLE \
551 SS_ONSTACK mcontext_t pid_t sig_atomic_t sigevent siginfo_t sigset_t \
552 sigstack sigval stack_t ucontext_t
553# generated via this:
554# perl -lne '/^#ifdef (SIG\w+)/ and print $1' lib/sig2str.c|sort -u|fmt -70
555_sig_names = \
556 SIGABRT SIGALRM SIGALRM1 SIGBUS SIGCANCEL SIGCHLD SIGCLD SIGCONT \
557 SIGDANGER SIGDIL SIGEMT SIGFPE SIGFREEZE SIGGRANT SIGHUP SIGILL \
558 SIGINFO SIGINT SIGIO SIGIOT SIGKAP SIGKILL SIGKILLTHR SIGLOST SIGLWP \
559 SIGMIGRATE SIGMSG SIGPHONE SIGPIPE SIGPOLL SIGPRE SIGPROF SIGPWR \
560 SIGQUIT SIGRETRACT SIGSAK SIGSEGV SIGSOUND SIGSTKFLT SIGSTOP SIGSYS \
561 SIGTERM SIGTHAW SIGTRAP SIGTSTP SIGTTIN SIGTTOU SIGURG SIGUSR1 \
562 SIGUSR2 SIGVIRT SIGVTALRM SIGWAITING SIGWINCH SIGWIND SIGWINDOW \
563 SIGXCPU SIGXFSZ
564_sig_syms_re = $(subst $(_sp),|,$(strip $(_sig_names) $(_sig_types_and_consts)))
565
566# Prohibit the inclusion of signal.h without an actual use.
567sc_prohibit_signal_without_use:
568 @h='<signal.h>' \
569 re='\<($(_sig_function_re)) *\(|\<($(_sig_syms_re))\>' \
a927b6c1
LC
570 $(_sc_header_without_use)
571
572# Prohibit the inclusion of strings.h without a sensible use.
573# Using the likes of bcmp, bcopy, bzero, index or rindex is not sensible.
574sc_prohibit_strings_without_use:
575 @h='<strings.h>' \
576 re='\<(strn?casecmp|ffs(ll)?)\>' \
577 $(_sc_header_without_use)
578
579# Get the list of symbol names with this:
580# perl -lne '/^# *define (\w+)\(/ and print $1' lib/intprops.h|grep -v '^s'|fmt
581_intprops_names = \
582 TYPE_IS_INTEGER TYPE_TWOS_COMPLEMENT TYPE_ONES_COMPLEMENT \
583 TYPE_SIGNED_MAGNITUDE TYPE_SIGNED TYPE_MINIMUM TYPE_MAXIMUM \
584 INT_STRLEN_BOUND INT_BUFSIZE_BOUND
585_intprops_syms_re = $(subst $(_sp),|,$(strip $(_intprops_names)))
586# Prohibit the inclusion of intprops.h without an actual use.
587sc_prohibit_intprops_without_use:
588 @h='"intprops.h"' \
589 re='\<($(_intprops_syms_re)) *\(' \
590 $(_sc_header_without_use)
c84bdaf6 591
49114fd4
LC
592_stddef_syms_re = NULL|offsetof|ptrdiff_t|size_t|wchar_t
593# Prohibit the inclusion of stddef.h without an actual use.
594sc_prohibit_stddef_without_use:
595 @h='<stddef.h>' \
596 re='\<($(_stddef_syms_re)) *\(' \
597 $(_sc_header_without_use)
598
c84bdaf6 599sc_obsolete_symbols:
a927b6c1
LC
600 @prohibit='\<(HAVE''_FCNTL_H|O''_NDELAY)\>' \
601 halt='do not use HAVE''_FCNTL_H or O'_NDELAY \
602 $(_sc_search_regexp)
c84bdaf6
LC
603
604# FIXME: warn about definitions of EXIT_FAILURE, EXIT_SUCCESS, STREQ
605
606# Each nonempty ChangeLog line must start with a year number, or a TAB.
607sc_changelog:
a927b6c1
LC
608 @prohibit='^[^12 ]' \
609 in_vc_files='^ChangeLog$$' \
610 halt='found unexpected prefix in a ChangeLog' \
611 $(_sc_search_regexp)
c84bdaf6
LC
612
613# Ensure that each .c file containing a "main" function also
614# calls set_program_name.
615sc_program_name:
a927b6c1
LC
616 @require='set_program_name *\(m?argv\[0\]\);' \
617 in_vc_files='\.c$$' \
0f00f2c3 618 containing='\<main *(' \
a927b6c1
LC
619 halt='the above files do not call set_program_name' \
620 $(_sc_search_regexp)
c84bdaf6 621
0f00f2c3
LC
622# Ensure that each .c file containing a "main" function also
623# calls bindtextdomain.
624sc_bindtextdomain:
625 @require='bindtextdomain *\(' \
626 in_vc_files='\.c$$' \
627 containing='\<main *(' \
628 halt='the above files do not call bindtextdomain' \
629 $(_sc_search_regexp)
630
c84bdaf6
LC
631# Require that the final line of each test-lib.sh-using test be this one:
632# Exit $fail
633# Note: this test requires GNU grep's --label= option.
634Exit_witness_file ?= tests/test-lib.sh
635Exit_base := $(notdir $(Exit_witness_file))
636sc_require_test_exit_idiom:
637 @if test -f $(srcdir)/$(Exit_witness_file); then \
638 die=0; \
639 for i in $$(grep -l -F 'srcdir/$(Exit_base)' \
640 $$($(VC_LIST) tests)); do \
641 tail -n1 $$i | grep '^Exit .' > /dev/null \
642 && : || { die=1; echo $$i; } \
643 done; \
644 test $$die = 1 && \
645 { echo 1>&2 '$(ME): the final line in each of the above is not:'; \
646 echo 1>&2 'Exit something'; \
647 exit 1; } || :; \
648 fi
649
650sc_the_the:
a927b6c1
LC
651 @prohibit='\<the ''the\>' \
652 ignore_case=1 \
653 halt='found use of "the ''the";' \
654 $(_sc_search_regexp)
c84bdaf6
LC
655
656sc_trailing_blank:
a927b6c1
LC
657 @prohibit='[ ]$$' \
658 halt='found trailing blank(s)' \
659 $(_sc_search_regexp)
c84bdaf6
LC
660
661# Match lines like the following, but where there is only one space
662# between the options and the description:
663# -D, --all-repeated[=delimit-method] print all duplicate lines\n
664longopt_re = --[a-z][0-9A-Za-z-]*(\[?=[0-9A-Za-z-]*\]?)?
665sc_two_space_separator_in_usage:
a927b6c1
LC
666 @prohibit='^ *(-[A-Za-z],)? $(longopt_re) [^ ].*\\$$' \
667 halt='help2man requires at least two spaces between an option and its description'\
668 $(_sc_search_regexp)
c84bdaf6
LC
669
670# Look for diagnostics that aren't marked for translation.
671# This won't find any for which error's format string is on a separate line.
672sc_unmarked_diagnostics:
673 @grep -nE \
a927b6c1 674 '\<error *\([^"]*"[^"]*[a-z]{3}' $$($(VC_LIST_EXCEPT)) \
dd7d0148 675 | grep -Ev '(_|ngettext ?)\(' && \
c84bdaf6
LC
676 { echo '$(ME): found unmarked diagnostic(s)' 1>&2; \
677 exit 1; } || :
678
679# Avoid useless parentheses like those in this example:
680# #if defined (SYMBOL) || defined (SYM2)
681sc_useless_cpp_parens:
a927b6c1
LC
682 @prohibit='^# *if .*defined *\(' \
683 halt='found useless parentheses in cpp directive' \
684 $(_sc_search_regexp)
685
686# List headers for which HAVE_HEADER_H is always true, assuming you are
687# using the appropriate gnulib module. CAUTION: for each "unnecessary"
688# #if HAVE_HEADER_H that you remove, be sure that your project explicitly
689# requires the gnulib module that guarantees the usability of that header.
690gl_assured_headers_ = \
691 cd $(gnulib_dir)/lib && echo *.in.h|sed 's/\.in\.h//g'
692
693# Convert the list of names to upper case, and replace each space with "|".
694az_ = abcdefghijklmnopqrstuvwxyz
695AZ_ = ABCDEFGHIJKLMNOPQRSTUVWXYZ
696gl_header_upper_case_or_ = \
697 $$($(gl_assured_headers_) \
698 | tr $(az_)/.- $(AZ_)___ \
699 | tr -s ' ' '|' \
700 )
701sc_prohibit_always_true_header_tests:
702 @or=$(gl_header_upper_case_or_); \
703 re="HAVE_($$or)_H"; \
704 prohibit='\<'"$$re"'\>' \
0f00f2c3
LC
705 halt=$$(printf '%s\n' \
706 'do not test the above HAVE_<header>_H symbol(s);' \
707 ' with the corresponding gnulib module, they are always true') \
a927b6c1
LC
708 $(_sc_search_regexp)
709
710# ==================================================================
711gl_other_headers_ ?= \
712 intprops.h \
713 openat.h \
714 stat-macros.h
715
716# Perl -lne code to extract "significant" cpp-defined symbols from a
717# gnulib header file, eliminating a few common false-positives.
718gl_extract_significant_defines_ = \
719 /^\# *define ([^_ (][^ (]*)(\s*\(|\s+\w+)/\
720 && $$2 !~ /(?:rpl_|_used_without_)/\
721 && $$1 !~ /^(?:NSIG|ATTRIBUTE_NORETURN)$$/\
722 and print $$1
723
724# Create a list of regular expressions matching the names
725# of macros that are guaranteed to be defined by parts of gnulib.
726define def_sym_regex
727 gen_h=$(gl_generated_headers_); \
728 (cd $(gnulib_dir)/lib; \
729 for f in *.in.h $(gl_other_headers_); do \
730 perl -lne '$(gl_extract_significant_defines_)' $$f; \
731 done; \
732 ) | sort -u \
733 | grep -Ev '^ATTRIBUTE_NORETURN' \
734 | sed 's/^/^ *# *(define|undef) */;s/$$/\\>/'
735endef
736
737# Don't define macros that we already get from gnulib header files.
738sc_prohibit_always-defined_macros:
739 @if test -d $(gnulib_dir); then \
740 case $$(echo all: | grep -l -f - Makefile) in Makefile);; *) \
741 echo '$(ME): skipping $@: you lack GNU grep' 1>&2; exit 0;; \
742 esac; \
743 $(def_sym_regex) | grep -E -f - $$($(VC_LIST_EXCEPT)) \
744 && { echo '$(ME): define the above via some gnulib .h file' \
745 1>&2; exit 1; } || :; \
746 fi
747# ==================================================================
748
749# Prohibit checked in backup files.
750sc_prohibit_backup_files:
751 @$(VC_LIST) | grep '~$$' && \
752 { echo '$(ME): found version controlled backup file' 1>&2; \
753 exit 1; } || :
c84bdaf6
LC
754
755# Require the latest GPL.
756sc_GPL_version:
a927b6c1
LC
757 @prohibit='either ''version [^3]' \
758 halt='GPL vN, N!=3' \
759 $(_sc_search_regexp)
c84bdaf6 760
61cd9dc9
LC
761# Require the latest GFDL. Two regexp, since some .texi files end up
762# line wrapping between 'Free Documentation License,' and 'Version'.
763_GFDL_regexp = (Free ''Documentation.*Version 1\.[^3]|Version 1\.[^3] or any)
764sc_GFDL_version:
a927b6c1
LC
765 @prohibit='$(_GFDL_regexp)' \
766 halt='GFDL vN, N!=3' \
767 $(_sc_search_regexp)
768
0f00f2c3
LC
769# Don't use Texinfo's @acronym{}.
770# http://lists.gnu.org/archive/html/bug-gnulib/2010-03/msg00321.html
a927b6c1
LC
771texinfo_suffix_re_ ?= \.(txi|texi(nfo)?)$$
772sc_texinfo_acronym:
773 @prohibit='@acronym\{' \
774 in_vc_files='$(texinfo_suffix_re_)' \
775 halt='found use of Texinfo @acronym{}' \
776 $(_sc_search_regexp)
61cd9dc9 777
c84bdaf6
LC
778cvs_keywords = \
779 Author|Date|Header|Id|Name|Locker|Log|RCSfile|Revision|Source|State
780
781sc_prohibit_cvs_keyword:
a927b6c1
LC
782 @prohibit='\$$($(cvs_keywords))\$$' \
783 halt='do not use CVS keyword expansion' \
784 $(_sc_search_regexp)
785
786# This Perl code is slightly obfuscated. Not only is each "$" doubled
787# because it's in a Makefile, but the $$c's are comments; we cannot
788# use "#" due to the way the script ends up concatenated onto one line.
789# It would be much more concise, and would produce better output (including
790# counts) if written as:
791# perl -ln -0777 -e '/\n(\n+)$/ and print "$ARGV: ".length $1' ...
792# but that would be far less efficient, reading the entire contents
793# of each file, rather than just the last two bytes of each.
dd36ce77
MW
794# In addition, while the code below detects both blank lines and a missing
795# newline at EOF, the above detects only the former.
a927b6c1
LC
796#
797# This is a perl script that is expected to be the single-quoted argument
798# to a command-line "-le". The remaining arguments are file names.
dd36ce77
MW
799# Print the name of each file that ends in exactly one newline byte.
800# I.e., warn if there are blank lines (2 or more newlines), or if the
801# last byte is not a newline. However, currently we don't complain
802# about any file that contains exactly one byte.
a927b6c1
LC
803# Exit nonzero if at least one such file is found, otherwise, exit 0.
804# Warn about, but otherwise ignore open failure. Ignore seek/read failure.
805#
806# Use this if you want to remove trailing empty lines from selected files:
807# perl -pi -0777 -e 's/\n\n+$/\n/' files...
808#
dd36ce77 809require_exactly_one_NL_at_EOF_ = \
a927b6c1
LC
810 foreach my $$f (@ARGV) \
811 { \
812 open F, "<", $$f or (warn "failed to open $$f: $$!\n"), next; \
813 my $$p = sysseek (F, -2, 2); \
814 my $$c = "seek failure probably means file has < 2 bytes; ignore"; \
815 my $$last_two_bytes; \
816 defined $$p and $$p = sysread F, $$last_two_bytes, 2; \
817 close F; \
818 $$c = "ignore read failure"; \
dd36ce77
MW
819 $$p && ($$last_two_bytes eq "\n\n" \
820 || substr ($$last_two_bytes,1) ne "\n") \
821 and (print $$f), $$fail=1; \
a927b6c1
LC
822 } \
823 END { exit defined $$fail }
824sc_prohibit_empty_lines_at_EOF:
dd36ce77 825 @perl -le '$(require_exactly_one_NL_at_EOF_)' $$($(VC_LIST_EXCEPT)) \
dd7d0148
LC
826 || { echo '$(ME): empty line(s) or no newline at EOF' \
827 1>&2; exit 1; } || :
c84bdaf6
LC
828
829# Make sure we don't use st_blocks. Use ST_NBLOCKS instead.
830# This is a bit of a kludge, since it prevents use of the string
831# even in comments, but for now it does the job with no false positives.
832sc_prohibit_stat_st_blocks:
a927b6c1
LC
833 @prohibit='[.>]st_blocks' \
834 halt='do not use st_blocks; use ST_NBLOCKS' \
835 $(_sc_search_regexp)
c84bdaf6
LC
836
837# Make sure we don't define any S_IS* macros in src/*.c files.
838# They're already defined via gnulib's sys/stat.h replacement.
839sc_prohibit_S_IS_definition:
a927b6c1
LC
840 @prohibit='^ *# *define *S_IS' \
841 halt='do not define S_IS* macros; include <sys/stat.h>' \
842 $(_sc_search_regexp)
843
dd7d0148
LC
844prohibit_doubled_word_RE_ ?= \
845 /\b(then?|[iao]n|i[fst]|but|f?or|at|and|[dt]o)\s+\1\b/gims
846prohibit_doubled_word_ = \
847 -e 'while ($(prohibit_doubled_word_RE_))' \
848 -e ' {' \
849 -e ' $$n = ($$` =~ tr/\n/\n/ + 1);' \
850 -e ' ($$v = $$&) =~ s/\n/\\n/g;' \
851 -e ' print "$$ARGV:$$n:$$v\n";' \
852 -e ' }'
853
854# Define this to a regular expression that matches
855# any filename:dd:match lines you want to ignore.
856# The default is to ignore no matches.
857ignore_doubled_word_match_RE_ ?= ^$$
858
859sc_prohibit_doubled_word:
860 @perl -n -0777 $(prohibit_doubled_word_) $$($(VC_LIST_EXCEPT)) \
861 | grep -vE '$(ignore_doubled_word_match_RE_)' \
862 | grep . && { echo '$(ME): doubled words' 1>&2; exit 1; } || :
863
864sc_prohibit_can_not:
865 @prohibit='\<can[ ]not\>' \
866 halt='use "cannot", not "can'' not"' \
867 $(_sc_search_regexp)
868
a927b6c1
LC
869_ptm1 = use "test C1 && test C2", not "test C1 -''a C2"
870_ptm2 = use "test C1 || test C2", not "test C1 -''o C2"
871# Using test's -a and -o operators is not portable.
872# We prefer test over [, since the latter is spelled [[ in configure.ac.
873sc_prohibit_test_minus_ao:
874 @prohibit='(\<test| \[+) .+ -[ao] ' \
875 halt='$(_ptm1); $(_ptm2)' \
876 $(_sc_search_regexp)
c84bdaf6 877
0f00f2c3
LC
878# Avoid a test bashism.
879sc_prohibit_test_double_equal:
880 @prohibit='(\<test| \[+) .+ == ' \
881 containing='#! */bin/[a-z]*sh' \
882 halt='use "test x = x", not "test x =''= x"' \
883 $(_sc_search_regexp)
884
61cd9dc9
LC
885# Each program that uses proper_name_utf8 must link with one of the
886# ICONV libraries. Otherwise, some ICONV library must appear in LDADD.
887# The perl -0777 invocation below extracts the possibly-multi-line
888# definition of LDADD from the appropriate Makefile.am and exits 0
889# when it contains "ICONV".
c84bdaf6
LC
890sc_proper_name_utf8_requires_ICONV:
891 @progs=$$(grep -l 'proper_name_utf8 ''("' $$($(VC_LIST_EXCEPT)));\
892 if test "x$$progs" != x; then \
893 fail=0; \
894 for p in $$progs; do \
895 dir=$$(dirname "$$p"); \
61cd9dc9
LC
896 perl -0777 \
897 -ne 'exit !(/^LDADD =(.+?[^\\]\n)/ms && $$1 =~ /ICONV/)' \
898 $$dir/Makefile.am && continue; \
c84bdaf6
LC
899 base=$$(basename "$$p" .c); \
900 grep "$${base}_LDADD.*ICONV)" $$dir/Makefile.am > /dev/null \
901 || { fail=1; echo 1>&2 "$(ME): $$p uses proper_name_utf8"; }; \
902 done; \
903 test $$fail = 1 && \
904 { echo 1>&2 '$(ME): the above do not link with any ICONV library'; \
905 exit 1; } || :; \
906 fi
907
908# Warn about "c0nst struct Foo const foo[]",
909# but not about "char const *const foo" or "#define const const".
910sc_redundant_const:
a927b6c1
LC
911 @prohibit='\bconst\b[[:space:][:alnum:]]{2,}\bconst\b' \
912 halt='redundant "const" in declarations' \
913 $(_sc_search_regexp)
c84bdaf6
LC
914
915sc_const_long_option:
916 @grep '^ *static.*struct option ' $$($(VC_LIST_EXCEPT)) \
917 | grep -Ev 'const struct option|struct option const' && { \
918 echo 1>&2 '$(ME): add "const" to the above declarations'; \
919 exit 1; } || :
920
921NEWS_hash = \
922 $$(sed -n '/^\*.* $(PREV_VERSION_REGEXP) ([0-9-]*)/,$$p' \
923 $(srcdir)/NEWS \
61cd9dc9
LC
924 | perl -0777 -pe \
925 's/^Copyright.+?Free\sSoftware\sFoundation,\sInc\.\n//ms' \
c84bdaf6
LC
926 | md5sum - \
927 | sed 's/ .*//')
928
929# Ensure that we don't accidentally insert an entry into an old NEWS block.
930sc_immutable_NEWS:
931 @if test -f $(srcdir)/NEWS; then \
932 test "$(NEWS_hash)" = '$(old_NEWS_hash)' && : || \
933 { echo '$(ME): you have modified old NEWS' 1>&2; exit 1; }; \
934 fi
935
936# Update the hash stored above. Do this after each release and
937# for any corrections to old entries.
938update-NEWS-hash: NEWS
939 perl -pi -e 's/^(old_NEWS_hash[ \t]+:?=[ \t]+).*/$${1}'"$(NEWS_hash)/" \
940 $(srcdir)/cfg.mk
941
942# Ensure that we use only the standard $(VAR) notation,
943# not @...@ in Makefile.am, now that we can rely on automake
944# to emit a definition for each substituted variable.
dd7d0148
LC
945# However, there is still one case in which @VAR@ use is not just
946# legitimate, but actually required: when augmenting an automake-defined
947# variable with a prefix. For example, gettext uses this:
948# MAKEINFO = env LANG= LC_MESSAGES= LC_ALL= LANGUAGE= @MAKEINFO@
949# otherwise, makeinfo would put German or French (current locale)
950# navigation hints in the otherwise-English documentation.
951#
61cd9dc9
LC
952# Allow the package to add exceptions via a hook in cfg.mk;
953# for example, @PRAGMA_SYSTEM_HEADER@ can be permitted by
954# setting this to ' && !/PRAGMA_SYSTEM_HEADER/'.
955_makefile_at_at_check_exceptions ?=
956sc_makefile_at_at_check:
dd7d0148
LC
957 @perl -ne '/\@[A-Z_0-9]+\@/' \
958 -e ' && !/([A-Z_0-9]+)\s+=.*\@\1\@$$/' \
959 -e ''$(_makefile_at_at_check_exceptions) \
c84bdaf6 960 -e 'and (print "$$ARGV:$$.: $$_"), $$m=1; END {exit !$$m}' \
dd7d0148 961 $$($(VC_LIST_EXCEPT) | grep -E '(^|/)(Makefile\.am|[^/]+\.mk)$$') \
c84bdaf6
LC
962 && { echo '$(ME): use $$(...), not @...@' 1>&2; exit 1; } || :
963
1cd4fffc 964news-check: NEWS
9157d901
LC
965 if sed -n $(news-check-lines-spec)p $(srcdir)/NEWS \
966 | grep -E $(news-check-regexp) >/dev/null; then \
c84bdaf6
LC
967 :; \
968 else \
1cd4fffc 969 echo 'NEWS: $$(news-check-regexp) failed to match' 1>&2; \
c84bdaf6
LC
970 exit 1; \
971 fi
972
973sc_makefile_TAB_only_indentation:
a927b6c1
LC
974 @prohibit='^ [ ]{8}' \
975 in_vc_files='akefile|\.mk$$' \
976 halt='found TAB-8-space indentation' \
977 $(_sc_search_regexp)
c84bdaf6
LC
978
979sc_m4_quote_check:
a927b6c1
LC
980 @prohibit='(AC_DEFINE(_UNQUOTED)?|AC_DEFUN)\([^[]' \
981 in_vc_files='(^configure\.ac|\.m4)$$' \
982 halt='quote the first arg to AC_DEF*' \
983 $(_sc_search_regexp)
c84bdaf6
LC
984
985fix_po_file_diag = \
986'you have changed the set of files with translatable diagnostics;\n\
987apply the above patch\n'
988
989# Verify that all source files using _() are listed in po/POTFILES.in.
dd7d0148 990po_file ?= $(srcdir)/po/POTFILES.in
c84bdaf6
LC
991sc_po_check:
992 @if test -f $(po_file); then \
993 grep -E -v '^(#|$$)' $(po_file) \
994 | grep -v '^src/false\.c$$' | sort > $@-1; \
995 files=; \
dd7d0148 996 for file in $$($(VC_LIST_EXCEPT)) $(srcdir)/lib/*.[ch]; do \
c84bdaf6
LC
997 test -r $$file || continue; \
998 case $$file in \
999 *.m4|*.mk) continue ;; \
1000 *.?|*.??) ;; \
1001 *) continue;; \
1002 esac; \
1003 case $$file in \
1004 *.[ch]) \
1005 base=`expr " $$file" : ' \(.*\)\..'`; \
1006 { test -f $$base.l || test -f $$base.y; } && continue;; \
1007 esac; \
1008 files="$$files $$file"; \
1009 done; \
1010 grep -E -l '\b(N?_|gettext *)\([^)"]*("|$$)' $$files \
dd7d0148 1011 | sed 's|^$(_dot_escaped_srcdir)/||' | sort -u > $@-2; \
c84bdaf6
LC
1012 diff -u -L $(po_file) -L $(po_file) $@-1 $@-2 \
1013 || { printf '$(ME): '$(fix_po_file_diag) 1>&2; exit 1; }; \
1014 rm -f $@-1 $@-2; \
1015 fi
1016
1017# Sometimes it is useful to change the PATH environment variable
1018# in Makefiles. When doing so, it's better not to use the Unix-centric
1019# path separator of `:', but rather the automake-provided `$(PATH_SEPARATOR)'.
1020msg = '$(ME): Do not use `:'\'' above; use $$(PATH_SEPARATOR) instead'
1021sc_makefile_path_separator_check:
a927b6c1
LC
1022 @prohibit='PATH[=].*:' \
1023 in_vc_files='akefile|\.mk$$' \
1024 halt=$(msg) \
1025 $(_sc_search_regexp)
c84bdaf6
LC
1026
1027# Check that `make alpha' will not fail at the end of the process.
1028writable-files:
1029 if test -d $(release_archive_dir); then :; else \
1030 for file in $(distdir).tar.gz \
1031 $(release_archive_dir)/$(distdir).tar.gz; do \
1032 test -e $$file || continue; \
1033 test -w $$file \
1034 || { echo ERROR: $$file is not writable; fail=1; }; \
1035 done; \
1036 test "$$fail" && exit 1 || : ; \
1037 fi
1038
2e65b52f 1039v_etc_file = $(gnulib_dir)/lib/version-etc.c
c84bdaf6
LC
1040sample-test = tests/sample-test
1041texi = doc/$(PACKAGE).texi
1042# Make sure that the copyright date in $(v_etc_file) is up to date.
1043# Do the same for the $(sample-test) and the main doc/.texi file.
1044sc_copyright_check:
a927b6c1
LC
1045 @require='enum { COPYRIGHT_YEAR = '$$(date +%Y)' };' \
1046 in_files=$(v_etc_file) \
1047 halt='out of date copyright in $(v_etc_file); update it' \
1048 $(_sc_search_regexp)
1049 @require='# Copyright \(C\) '$$(date +%Y)' Free' \
1050 in_vc_files=$(sample-test) \
1051 halt='out of date copyright in $(sample-test); update it' \
1052 $(_sc_search_regexp)
1053 @require='Copyright @copyright\{\} .*'$$(date +%Y)' Free' \
1054 in_vc_files=$(texi) \
1055 halt='out of date copyright in $(texi); update it' \
1056 $(_sc_search_regexp)
1057
1058# If tests/help-version exists and seems to be new enough, assume that its
1059# use of init.sh and path_prepend_ is correct, and ensure that every other
1060# use of init.sh is identical.
1061# This is useful because help-version cross-checks prog --version
1062# with $(VERSION), which verifies that its path_prepend_ invocation
1063# sets PATH correctly. This is an inexpensive way to ensure that
1064# the other init.sh-using tests also get it right.
1065_hv_file ?= $(srcdir)/tests/help-version
1066_hv_regex_weak ?= ^ *\. .*/init\.sh"
1067_hv_regex_strong ?= ^ *\. "\$${srcdir=\.}/init\.sh"
1068sc_cross_check_PATH_usage_in_tests:
1069 @if test -f $(_hv_file); then \
1070 grep -l 'VERSION mismatch' $(_hv_file) >/dev/null \
1071 || { echo "$@: skipped: no such file: $(_hv_file)" 1>&2; \
1072 exit 0; }; \
1073 grep -lE '$(_hv_regex_strong)' $(_hv_file) >/dev/null \
1074 || { echo "$@: $(_hv_file) lacks conforming use of init.sh" 1>&2; \
1075 exit 1; }; \
1076 good=$$(grep -E '$(_hv_regex_strong)' $(_hv_file)); \
1077 grep -LFx "$$good" \
1078 $$(grep -lE '$(_hv_regex_weak)' $$($(VC_LIST_EXCEPT))) \
1079 | grep . && \
1080 { echo "$(ME): the above files use path_prepend_ inconsistently" \
1081 1>&2; exit 1; } || :; \
c84bdaf6
LC
1082 fi
1083
61cd9dc9
LC
1084# #if HAVE_... will evaluate to false for any non numeric string.
1085# That would be flagged by using -Wundef, however gnulib currently
1086# tests many undefined macros, and so we can't enable that option.
1087# So at least preclude common boolean strings as macro values.
1088sc_Wundef_boolean:
a927b6c1
LC
1089 @prohibit='^#define.*(yes|no|true|false)$$' \
1090 in_files='$(CONFIG_INCLUDE)' \
1091 halt='Use 0 or 1 for macro values' \
1092 $(_sc_search_regexp)
61cd9dc9
LC
1093
1094sc_vulnerable_makefile_CVE-2009-4029:
a927b6c1
LC
1095 @prohibit='perm -777 -exec chmod a\+rwx|chmod 777 \$$\(distdir\)' \
1096 in_files=$$(find $(srcdir) -name Makefile.in) \
0f00f2c3
LC
1097 halt=$$(printf '%s\n' \
1098 'the above files are vulnerable; beware of running' \
1099 ' "make dist*" rules, and upgrade to fixed automake' \
1100 ' see http://bugzilla.redhat.com/542609 for details') \
a927b6c1 1101 $(_sc_search_regexp)
61cd9dc9 1102
c84bdaf6
LC
1103vc-diff-check:
1104 (unset CDPATH; cd $(srcdir) && $(VC) diff) > vc-diffs || :
1105 if test -s vc-diffs; then \
1106 cat vc-diffs; \
1107 echo "Some files are locally modified:" 1>&2; \
1108 exit 1; \
1109 else \
1110 rm vc-diffs; \
1111 fi
1112
c84bdaf6
LC
1113rel-files = $(DIST_ARCHIVES)
1114
1115gnulib_dir ?= $(srcdir)/gnulib
1116gnulib-version = $$(cd $(gnulib_dir) && git describe)
1117bootstrap-tools ?= autoconf,automake,gnulib
1118
61cd9dc9
LC
1119# If it's not already specified, derive the GPG key ID from
1120# the signed tag we've just applied to mark this release.
1121gpg_key_ID ?= \
1122 $$(git cat-file tag v$(VERSION) > .ann-sig \
1123 && gpgv .ann-sig - < /dev/null 2>&1 \
1124 | sed -n '/.*key ID \([0-9A-F]*\)/s//\1/p'; rm -f .ann-sig)
1125
a927b6c1
LC
1126translation_project_ ?= coordinator@translationproject.org
1127announcement_Cc_ ?= $(translation_project_), $(PACKAGE_BUGREPORT)
1128announcement_mail_headers_ ?= \
1129To: info-gnu@gnu.org \
1130Cc: $(announcement_Cc_) \
1131Mail-Followup-To: $(PACKAGE_BUGREPORT)
1132
c84bdaf6
LC
1133announcement: NEWS ChangeLog $(rel-files)
1134 @$(build_aux)/announce-gen \
a927b6c1 1135 --mail-headers='$(announcement_mail_headers_)' \
c84bdaf6
LC
1136 --release-type=$(RELEASE_TYPE) \
1137 --package=$(PACKAGE) \
1138 --prev=$(PREV_VERSION) \
1139 --curr=$(VERSION) \
1140 --gpg-key-id=$(gpg_key_ID) \
61cd9dc9 1141 --news=$(srcdir)/NEWS \
c84bdaf6
LC
1142 --bootstrap-tools=$(bootstrap-tools) \
1143 --gnulib-version=$(gnulib-version) \
1144 --no-print-checksums \
1145 $(addprefix --url-dir=, $(url_dir_list))
1146
1147## ---------------- ##
1148## Updating files. ##
1149## ---------------- ##
1150
1151ftp-gnu = ftp://ftp.gnu.org/gnu
1152www-gnu = http://www.gnu.org
1153
dde9c5a4 1154upload_dest_dir_ ?= $(PACKAGE)
c84bdaf6
LC
1155emit_upload_commands:
1156 @echo =====================================
1157 @echo =====================================
1158 @echo "$(build_aux)/gnupload $(GNUPLOADFLAGS) \\"
dde9c5a4 1159 @echo " --to $(gnu_rel_host):$(upload_dest_dir_) \\"
c84bdaf6 1160 @echo " $(rel-files)"
61cd9dc9 1161 @echo '# send the ~/announce-$(my_distdir) e-mail'
c84bdaf6
LC
1162 @echo =====================================
1163 @echo =====================================
1164
c84bdaf6
LC
1165define emit-commit-log
1166 printf '%s\n' 'post-release administrivia' '' \
1167 '* NEWS: Add header line for next release.' \
1168 '* .prev-version: Record previous version.' \
1169 '* cfg.mk (old_NEWS_hash): Auto-update.'
1170endef
1171
1172.PHONY: no-submodule-changes
1173no-submodule-changes:
1174 if test -d $(srcdir)/.git; then \
1175 diff=$$(cd $(srcdir) && git submodule -q foreach \
1176 git diff-index --name-only HEAD) \
1177 || exit 1; \
1178 case $$diff in '') ;; \
1179 *) echo '$(ME): submodule files are locally modified:'; \
1180 echo "$$diff"; exit 1;; esac; \
1181 else \
1182 : ; \
1183 fi
1184
49114fd4
LC
1185submodule-checks ?= no-submodule-changes public-submodule-commit
1186
1187# Ensure that each sub-module commit we're using is public.
1188# Without this, it is too easy to tag and release code that
1189# cannot be built from a fresh clone.
1190.PHONY: public-submodule-commit
1191public-submodule-commit:
1192 $(AM_V_GEN)if test -d $(srcdir)/.git; then \
1193 cd $(srcdir) && \
1194 git submodule --quiet foreach test '$$(git rev-parse $$sha1)' \
1195 = '$$(git merge-base origin $$sha1)' \
1196 || { echo '$(ME): found non-public submodule commit' >&2; \
1197 exit 1; }; \
1198 else \
1199 : ; \
1200 fi
1201# This rule has a high enough utility/cost ratio that it should be a
1202# dependent of "check" by default. However, some of us do occasionally
1203# commit a temporary change that deliberately points to a non-public
1204# submodule commit, and want to be able to use rules like "make check".
1205# In that case, run e.g., "make check gl_public_submodule_commit="
1206# to disable this test.
1207gl_public_submodule_commit ?= public-submodule-commit
1208check: $(gl_public_submodule_commit)
1209
c84bdaf6
LC
1210.PHONY: alpha beta stable
1211ALL_RECURSIVE_TARGETS += alpha beta stable
49114fd4 1212alpha beta stable: $(local-check) writable-files $(submodule-checks)
c84bdaf6
LC
1213 test $@ = stable \
1214 && { echo $(VERSION) | grep -E '^[0-9]+(\.[0-9]+)+$$' \
1215 || { echo "invalid version string: $(VERSION)" 1>&2; exit 1;};}\
1216 || :
1217 $(MAKE) vc-diff-check
1cd4fffc 1218 $(MAKE) news-check
c84bdaf6
LC
1219 $(MAKE) distcheck
1220 $(MAKE) dist XZ_OPT=-9ev
1cd4fffc
LC
1221 $(MAKE) $(release-prep-hook) RELEASE_TYPE=$@
1222 $(MAKE) -s emit_upload_commands RELEASE_TYPE=$@
1223
1224# Override this in cfg.mk if you follow different procedures.
1225release-prep-hook ?= release-prep
1226
0f00f2c3 1227gl_noteworthy_news_ = * Noteworthy changes in release ?.? (????-??-??) [?]
1cd4fffc
LC
1228.PHONY: release-prep
1229release-prep:
1230 case $$RELEASE_TYPE in alpha|beta|stable) ;; \
1231 *) echo "invalid RELEASE_TYPE: $$RELEASE_TYPE" 1>&2; exit 1;; esac
61cd9dc9 1232 $(MAKE) -s announcement > ~/announce-$(my_distdir)
c84bdaf6
LC
1233 if test -d $(release_archive_dir); then \
1234 ln $(rel-files) $(release_archive_dir); \
1235 chmod a-w $(rel-files); \
1236 fi
c84bdaf6
LC
1237 echo $(VERSION) > $(prev_version_file)
1238 $(MAKE) update-NEWS-hash
0f00f2c3 1239 perl -pi -e '$$. == 3 and print "$(gl_noteworthy_news_)\n\n\n"' NEWS
c84bdaf6
LC
1240 $(emit-commit-log) > .ci-msg
1241 $(VC) commit -F .ci-msg -a
61cd9dc9 1242 rm .ci-msg
c84bdaf6 1243
a927b6c1
LC
1244# Override this with e.g., -s $(srcdir)/some_other_name.texi
1245# if the default $(PACKAGE)-derived name doesn't apply.
1246gendocs_options_ ?=
1247
c84bdaf6
LC
1248.PHONY: web-manual
1249web-manual:
1250 @test -z "$(manual_title)" \
1251 && { echo define manual_title in cfg.mk 1>&2; exit 1; } || :
1252 @cd '$(srcdir)/doc'; \
a927b6c1
LC
1253 $(SHELL) ../build-aux/gendocs.sh $(gendocs_options_) \
1254 -o '$(abs_builddir)/doc/manual' \
c84bdaf6
LC
1255 --email $(PACKAGE_BUGREPORT) $(PACKAGE) \
1256 "$(PACKAGE_NAME) - $(manual_title)"
1257 @echo " *** Upload the doc/manual directory to web-cvs."
1258
1259# Code Coverage
1260
1261init-coverage:
1262 $(MAKE) $(AM_MAKEFLAGS) clean
1263 lcov --directory . --zerocounters
1264
1265COVERAGE_CCOPTS ?= "-g --coverage"
1266COVERAGE_OUT ?= doc/coverage
1267
1268build-coverage:
1269 $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS)
1270 $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS) check
1271 mkdir -p $(COVERAGE_OUT)
1272 lcov --directory . --output-file $(COVERAGE_OUT)/$(PACKAGE).info \
1273 --capture
1274
1275gen-coverage:
1276 genhtml --output-directory $(COVERAGE_OUT) \
1277 $(COVERAGE_OUT)/$(PACKAGE).info \
1278 --highlight --frames --legend \
1279 --title "$(PACKAGE_NAME)"
1280
1281coverage: init-coverage build-coverage gen-coverage
1282
1283# Update gettext files.
1284PACKAGE ?= $(shell basename $(PWD))
1285PO_DOMAIN ?= $(PACKAGE)
1286POURL = http://translationproject.org/latest/$(PO_DOMAIN)/
1287PODIR ?= po
1288refresh-po:
1289 rm -f $(PODIR)/*.po && \
1290 echo "$(ME): getting translations into po (please ignore the robots.txt ERROR 404)..." && \
1291 wget --no-verbose --directory-prefix $(PODIR) --no-directories --recursive --level 1 --accept .po --accept .po.1 $(POURL) && \
1292 echo 'en@boldquot' > $(PODIR)/LINGUAS && \
1293 echo 'en@quot' >> $(PODIR)/LINGUAS && \
1294 ls $(PODIR)/*.po | sed 's/\.po//' | sed 's,$(PODIR)/,,' | sort >> $(PODIR)/LINGUAS
1295
a927b6c1 1296 # Running indent once is not idempotent, but running it twice is.
c84bdaf6
LC
1297INDENT_SOURCES ?= $(C_SOURCES)
1298.PHONY: indent
1299indent:
1300 indent $(INDENT_SOURCES)
a927b6c1 1301 indent $(INDENT_SOURCES)
c84bdaf6
LC
1302
1303# If you want to set UPDATE_COPYRIGHT_* environment variables,
1304# put the assignments in this variable.
1305update-copyright-env ?=
1306
1307# Run this rule once per year (usually early in January)
1308# to update all FSF copyright year lists in your project.
1309# If you have an additional project-specific rule,
1310# add it in cfg.mk along with a line 'update-copyright: prereq'.
1311# By default, exclude all variants of COPYING; you can also
1312# add exemptions (such as ChangeLog..* for rotated change logs)
1313# in the file .x-update-copyright.
1314.PHONY: update-copyright
1315update-copyright:
1316 grep -l -w Copyright \
1317 $$(export VC_LIST_EXCEPT_DEFAULT=COPYING && $(VC_LIST_EXCEPT)) \
1318 | $(update-copyright-env) xargs $(build_aux)/$@